#include <winsock2.h> 
#include <stdio.h>

#include <QCoreApplication>
#include <QSocketNotifier>

#include "client.h"


Client::Client(void)
{
  // Initialize Winsock.
  WSADATA wsaData;
  int iResult = WSAStartup( MAKEWORD(2,2), &wsaData );
  if ( iResult != NO_ERROR )
      printf("Error at WSAStartup()\n");

  // Create a socket.
  m_socket = socket( AF_INET, SOCK_STREAM, IPPROTO_TCP );

  if ( m_socket == INVALID_SOCKET ) {
      printf( "Error at socket(): %ld\n", WSAGetLastError() );
      WSACleanup();
      return;
  }

}

void Client::doConnect(void) 
{
  // Connect to a server.
  struct sockaddr_in clientService;

  clientService.sin_family = AF_INET;
  clientService.sin_addr.s_addr = inet_addr( "127.0.0.1" );
  clientService.sin_port = htons( 27015 );

  if ( ::connect( m_socket, (SOCKADDR*) &clientService, sizeof(clientService) ) == SOCKET_ERROR) {
      printf( "Failed to connect.\n" );
      WSACleanup();
      return;
  }
  printf( "connect.\n" );
 
}

void Client::write()
{

  // Send data.
  int bytesSent;
  char sendbuf[32] = "Client: Sending data.";

  bytesSent = send( m_socket, sendbuf, strlen(sendbuf), 0 );
  printf( "Bytes Sent: %ld\n", bytesSent );

}

void Client::close()
{
	closesocket(m_socket);
  printf( "connection close.\n" );
}

void Client::readwrite()
{

  // Send and receive data.
  int bytesSent;
  int bytesRecv = SOCKET_ERROR;
  char sendbuf[32] = "Client: Sending data.";
  char recvbuf[32] = "";

  bytesSent = send( m_socket, sendbuf, strlen(sendbuf), 0 );
  printf( "Bytes Sent: %ld\n", bytesSent );

  while( bytesRecv == SOCKET_ERROR ) {
      bytesRecv = recv( m_socket, recvbuf, 32, 0 );
      if ( bytesRecv == -1 ) {
          printf( "Connection Closed.\n");
          break;
      }
      if (bytesRecv < 0)
          return;
      printf( "Bytes Recv: %ld\n", bytesRecv );
  }
	getchar();
	closesocket(m_socket);
  return;
}



int main(int argc, char **argv) {
	
	QCoreApplication a(argc,argv); 
	
	Client b;
	b.doConnect();
	b.write();
	Sleep(3000);
	b.write();
	Sleep(3000);
	b.write();
	Sleep(3000);
	b.close();
//	a.exec();

}

