
#include <winsock2.h> 

#include <QCoreApplication>
#include <QSocketNotifier>

#include "server.h"


void Test::newClient( int socket )
{
	printf("%s %d\n",__FUNCTION__,socket); 
  p_socket = accept( socket, NULL, NULL );
  printf( "Client Connected %d.\n",p_socket);
	p_listen = new QSocketNotifier(p_socket,QSocketNotifier::Read);
	connect( p_listen, SIGNAL( activated(int) ), this, SLOT( processData(int) ) );

	p_listen = new QSocketNotifier(p_socket,QSocketNotifier::Exception);
	connect( p_listen, SIGNAL( activated(int) ), this, SLOT( processException(int) ) );
}

void Test::processData( int socket )
{
	printf("%s %d...",__FUNCTION__,socket); 
  // receive data.
  int bytesRecv = SOCKET_ERROR;
  char recvbuf[32] = "";
    
  bytesRecv = recv( socket, recvbuf, 32, 0 );
  printf( "Bytes Recv: %ld err=%d\n", bytesRecv,WSAGetLastError() );
}

void Test::processException( int socket )
{
	printf("%s %d...",__FUNCTION__,socket); 
  // receive data.
  int bytesRecv = SOCKET_ERROR;
  char recvbuf[32] = "";
  bytesRecv = recv( socket, recvbuf, 32, 0 );
  printf( "Bytes Recv: %ld err=%d\n", bytesRecv,WSAGetLastError() );
	
}



Test::Test()
{
  // Initialize Winsock.
  WSADATA wsaData;
  int iResult = WSAStartup( MAKEWORD(2,2), &wsaData );
  if ( iResult != NO_ERROR )
      printf("Error at WSAStartup()\n");

  // Create a socket.
  m_socket = socket( AF_INET, SOCK_STREAM, IPPROTO_TCP );

  if ( m_socket == INVALID_SOCKET ) {
      printf( "Error at socket(): %ld\n", WSAGetLastError() );
      WSACleanup();
      return;
  }

  // Bind the socket.
  struct sockaddr_in service;

  service.sin_family = AF_INET;
  service.sin_addr.s_addr = inet_addr( "127.0.0.1" );
  service.sin_port = htons( 27015 );

  if ( bind( m_socket, (SOCKADDR*) &service, sizeof(service) ) == SOCKET_ERROR ) {
      printf( "bind() failed.\n" );
      closesocket(m_socket);
      return;
  }
  printf( "socket bound.\n" );


	// Listen on the socket.
  if ( listen( m_socket, 3 ) == SOCKET_ERROR )
      printf( "Error listening on socket.\n");

	sn_listen = new QSocketNotifier(m_socket,QSocketNotifier::Read);
	
	connect( sn_listen, SIGNAL( activated(int) ), this, SLOT( newClient(int) ) );

  printf( "listening on socket.\n" );
  // Accept connections.
}

int Test::waitForConnection()
{
  SOCKET AcceptSocket;
  SOCKET p_socket;
	while(1) {
    printf( "Waiting for a client to connect...\n" );
    while (1) {
        AcceptSocket = (SOCKET)SOCKET_ERROR;
        while ( AcceptSocket == (SOCKET)SOCKET_ERROR ) {
            AcceptSocket = accept( m_socket, NULL, NULL );
        }
        printf( "Client Connected.\n");
        p_socket = AcceptSocket; 
        break;
    }
    
    // Send and receive data.
    int bytesSent;
    int bytesRecv = SOCKET_ERROR;
    char sendbuf[32] = "Server: Sending Data.";
    char recvbuf[32] = "";
    
    bytesRecv = recv( p_socket, recvbuf, 32, 0 );
    printf( "Bytes Recv: %ld\n", bytesRecv );
    
    bytesSent = send( p_socket, sendbuf, strlen(sendbuf), 0 );
    printf( "Bytes Sent: %ld\n", bytesSent );
//    shutdown(p_socket,SD_BOTH);
    closesocket(p_socket);
	}
	
  return 1;
}

void myMessageOutput(QtMsgType type, const char *msg)
{
    switch (type) {
    case QtDebugMsg:
        fprintf(stderr, "Debug: %s\n", msg);
        break;
    case QtWarningMsg:
        fprintf(stderr, "Warning: %s\n", msg);
        break;
    case QtCriticalMsg:
        fprintf(stderr, "Critical: %s\n", msg);
        break;
    case QtFatalMsg:
        fprintf(stderr, "Fatal: %s\n", msg);
        abort();
    }
}



int main(int argc, char **argv)
{
	qInstallMsgHandler(myMessageOutput);
	QCoreApplication a(argc,argv);

	Test test; 
	fprintf(stderr,"ererererererer\n");
	qWarning("sdsdsdsdsdsdsdsdsds\n");
//	test.waitForConnection();
	a.exec();
		
}	
